// Bug.m					SimpleBug

#import "Bug.h"
#import <random.h>
#import <collections.h>
#include "ModelSwarm.h"


@implementation Bug

- eatMe: (id)wrld
{
  //  printf("eatMeisrunning\n");
  bugworld =wrld;
  [bugworld putObject: nil atX: xPos Y: yPos];

  return self;
}

- setModelSwarm: (id)model
{
   id bugList;
   //   id firstBug;
   bugList = [model getBugList];
   //[bugList forEach: M(sayWhere)];
   //printf("the number of bugs is %d", [bugList getCount]);
   if ([bugList getCount] > 0)
   {   
     //firstBug = [bugList removeFirst]; //This makes all but one bug
                                           //disappear from the raster
                                           //but that one bug keeps
                                           //reporting his moves accurately
                                           //using sayWhere.

     //   firstBug = [bugList atOffset: 0];     //This lets all bugs exist on the
                                         //raster, but only one saysWhere,
                                         //and then he just keeps reporting 
                                         //where he was on the first move.

     //[firstBug sayWhere];
   }
   return self;
}

- sayWhere
{
  printf( "Bug at (%d,%d)\n", xPos, yPos);
  return self;
}

- setBugWorld: w Food: f
{
   bugworld = w;
   food = f;

   return self;
}

- createEnd
{
   [super createEnd];

   worldXSize = [bugworld getSizeX];
   worldYSize = [bugworld getSizeY];

   return self;
}

- setX: (int)x Y: (int)y
{
  xPos = x;
  yPos = y;

  return self;
}

- step
{
  int newX, newY;
  // id firstBug; 
  // id bugList;

  haveEaten = 0;

  // [self setModelSwarm: modelSwarm];
  //  firstBug = [bugList atOffset: 0];
  // [firstBug sayWhere];
   
   
  newX = xPos + [uniformIntRand getIntegerWithMin: -1 withMax: 1];
  newY = yPos + [uniformIntRand getIntegerWithMin: -1 withMax: 1];

  newX = (newX + worldXSize) % worldXSize;
  newY = (newY + worldYSize) % worldYSize;
  // [bugList forEach: M(sayWhere)];
  if ([bugworld getObjectAtX: newX Y: newY] == nil)
    {
      [bugworld putObject: nil atX: xPos Y: yPos];
      xPos = newX;
      yPos = newY;
      [bugworld putObject: self atX: newX Y: newY];
  
      //    printf( "Hey Dave, here are myX %d and myY %d\n", xPos, yPos);

    }
  
  if ([food getValueAtX: xPos Y: yPos] == 1)
    {
      [food putValue: 0 atX: xPos Y: yPos];
      haveEaten = 1; 
    }
  
  return self;
}

- drawSelfOn: (id <Raster>)r
{
  [r drawPointX: xPos Y: yPos Color: 3];
  return self;
}
  
@end















