// ModelSwarm.h					SimpleBug App

#import "Bug.h"
#import "Frog.h"
#import "FoodSpace.h"
#import <objectbase/Swarm.h>
#import <space.h>

@interface ModelSwarm: Swarm
{
  int worldXSize, worldYSize;
  float seedProb;
  float bugDensity;
  float frogDensity;

  FoodSpace *food;
  id <Grid2d> bugworld;
  id <Grid2d> frogworld;

  id modelSwarm;
  id bugList;
  id frogList;
  id modelActions;
  id modelSchedule;
}

- getModelSwarm;
- eatBug: (id)aBug;
- getBugList;
- getFrogList;
- getBugWorld;

- getFrogWorld;
- getFood;

+ createBegin: aZone;
- createEnd;
- buildObjects;
- buildActions;
- activateIn: swarmContext;

@end








