// Frog.m					

#import "Frog.h"
#import <random.h>
#import <collections.h>
#include "ModelSwarm.h"


@implementation Frog

- setModelSwarm: (id)modelSwarm
{
  //id frogList;
  //id firstFrog;
  //frogList = [modelSwarm getFrogList];
   //[frogList forEach: M(sayWhere)];
   //printf("the number of frogs is %d", [frogList getCount]);
   //if ([frogList getCount] > 0)
   //{   

   //firstFrog = [frogList removeFirst];   //This makes all but one frog
                                           //disappear from the raster
                                           //but that one frog keeps
                                           //reporting his moves accurately
                                           //using sayWhere.

   //firstFrog = [frogList atOffset: 0]; //This lets all frogs exist on the
                                         //raster, but only one saysWhere,
                                         //and then he just keeps reporting 
                                         //where he was on the first move.
  
  //[firstFrog sayWhere];
  //}
   return self;
}

- sayWhere
{
  printf( "Frog at (%d,%d)\n", xPos, yPos);
  return self;
}

- setFrogWorld: w Food: f
{
   frogworld = w;
   food = f;

   return self;
}

- createEnd
{
   [super createEnd];

   worldXSize = [frogworld getSizeX];
   worldYSize = [frogworld getSizeY];
   
   [self sayWhere];

   return self;
}

- setX: (int)x Y: (int)y
{
  xPos = x;
  yPos = y;

  return self;
}

- step
{
  int newX, newY;
  
  // haveEaten = 0;
 
  newX = xPos + [uniformIntRand getIntegerWithMin: -1 withMax: 1];
  newY = yPos + [uniformIntRand getIntegerWithMin: -1 withMax: 1];

  newX = (newX + worldXSize) % worldXSize;
  newY = (newY + worldYSize) % worldYSize;

  if ([frogworld getObjectAtX: newX Y: newY] == nil)
    {
      [frogworld putObject: nil atX: xPos Y: yPos];
      xPos = newX;
      yPos = newY;
      [frogworld putObject: self atX: newX Y: newY];
  
    }
  
  //if ([food getValueAtX: xPos Y: yPos] == 1)
  //  {
  //    [food putValue: 0 atX: xPos Y: yPos];
  //    haveEaten = 1; 
  //  }
  
  return self;
}

- drawSelfOn: (id <Raster>)r
{
  [r drawPointX: xPos Y: yPos Color: 2];
  return self;
}
  
@end















